#ifndef DIST_ARRAY_H
#define DIST_ARRAY_H


#include <mpi.h>

#include "typedefs.h"
#include "grid.h"

struct dist_array_t {
    int_t global_size[2], size[2], origin[2], border, n_buffers;
    real_t **data;
    MPI_Datatype column, row;
};


#define DARRAY(a,t,y,x) a->data[(t)][((y)+(a)->border)*((a)->size[1]+2*(a)->border)+((x)+(a)->border)]

dist_array_t * malloc_dist_array(int_t size[2], int_t border, int_t n_buffers);
void realloc_dist_array(dist_array_t *result, int_t gsize[2]);
void free_dist_array ( dist_array_t *old );
void border_exchange(dist_array_t *a, int_t t);
void swap_buffers ( dist_array_t *a );

#endif
