#ifndef SWE_H
#define SWE_H

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <math.h>
#include <mpi.h>

#include "dist_array.h"

/* Parametric data types */
#define mpi_real_t MPI_DOUBLE

/* MPI state */
int size, rank, dims[2], coords[2], north, south, east, west;
MPI_Comm cart;

// Used to index into the rank time array and profile function names array in a
// human readable way
enum profile_functions {
    add_child_grid_index,
    allocate_child_grid_index,
    boundary_index,
    downsample_index,
    grid_border_index,
    initialize_child_grids_index,
    integrate_time_step_index,
    malloc_index,
    memset_malloc_index,
    memset_realloc_index,
    mpi_type_index,
    rank_border_index,
    update_local_state_index,
    update_time_step_index,
    realloc_index,
    regrid_index,
    wait_index
};


typedef enum dim_type_t {
    automatic,
    manual
} dim_type_t;


void mirror_boundary(grid_t *grid, dist_array_t *m, int_t timestep);
void reverse_boundary(grid_t *grid, dist_array_t *m, int_t timestep);

#endif
